freeslot("MT_GODEXP")

local spawnTimers = {}

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.mo and player.mo.valid and player.mo.skin == "godzilla" then
            if player.mo.state == S_PLAY_DEAD then
                -- Initialize timer for the player if it doesn't exist
                if not spawnTimers[player] then
                    spawnTimers[player] = {time = leveltime, count = 0}
                end
                
                local timer = spawnTimers[player]
                
                -- Check if 0.1 seconds (4 tics) have passed since the last spawn
                if leveltime >= timer.time + 4 then
                    timer.time = leveltime -- Update the timer
                    timer.count = timer.count + 1 -- Increment the spawn count
                    
                    -- Generate random offsets for x, y, and z
                    local angle = FixedAngle(P_RandomRange(0, 359) * FRACUNIT) -- Convert random angle to fixed-point
                    local distance = FixedMul(P_RandomRange(0, 40) * FRACUNIT, FRACUNIT) -- Random distance up to 40 units
                    local x = player.mo.x + FixedMul(distance, cos(angle))
                    local y = player.mo.y + FixedMul(distance, sin(angle))
                    local z = player.mo.z + P_RandomRange(0, 70) * FRACUNIT -- Random z-offset up to 70 units
                    
                    -- Spawn explosion and play sound
                    local explosion = P_SpawnMobj(x, y, z, MT_GODEXP)
                    if explosion then
                        S_StartSound(explosion, sfx_GODHIT)
                    end
                    
                    -- Reset the counter after spawning 8 explosions
                    if timer.count >= 8 then
                        spawnTimers[player] = nil
                    end
                end
            else
                -- Reset the timer if the player leaves the state
                spawnTimers[player] = nil
            end
        end
    end
end)