freeslot("S_GODZILLA_FIGURE", "SPR_RAWR")

states[S_GODZILLA_FIGURE] = {
    sprite = SPR_RAWR,
    frame = FF_ANIMATE,
    nextstate = S_PLAY_STND
}

addHook("ThinkFrame", function()
    for player in players.iterate do
        player.taunttimer = player.taunttimer or 0
        player.taunttimer = player.taunttimer + 1

        -- Check if the player is in the 'godzilla' skin
        if player.mo.skin == "godzilla" then
            -- If the player is in the 'S_PLAY_STND' state, allow transition to 'S_GODZILLA_FIGURE'
            if player.mo.state == S_PLAY_STND then
                -- If the player presses the button for the flag toss and has a valid taunttimer
                if player.cmd.buttons & BT_TOSSFLAG and player.taunttimer >= 1 then
                    player.mo.state = S_GODZILLA_FIGURE
                    player.taunttimer = 0
                end
            end

            -- If the player is in 'S_GODZILLA_FIGURE', check if they move and send back to 'S_PLAY_STND'
            if player.mo.state == S_GODZILLA_FIGURE then
                -- Check if the player is moving by looking at cmd.forwardmove or cmd.sidemove
                if player.cmd.forwardmove ~= 0 or player.cmd.sidemove ~= 0 then
                    player.mo.state = S_PLAY_STND  -- Move back to standing state
                end
            end
        end
    end
end)