freeslot("S_GODZILLA_ROAR", "SPR_SKRE")

states[S_GODZILLA_ROAR] = {
    sprite = SPR_SKRE,
    frame = FF_ANIMATE,
    tics = 70,
    nextstate = S_PLAY_STND
}

addHook("ThinkFrame", function()
    for player in players.iterate do
        -- Check if player is in "godzilla" skin
        if player.mo.skin == "godzilla" then
            -- Check if the player presses the custom 2 button and is on the ground
            if player.cmd.buttons & BT_CUSTOM2 and P_IsObjectOnGround(player.mo) then
                -- Ensure the player is either in S_PLAY_STND or S_PLAY_WAIT before triggering the roar
                if player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_WAIT then
                    -- Play the sound and change to the GODZILLA_ROAR state
                    S_StartSound(player.mo, sfx_godror)
                    player.mo.state = S_GODZILLA_ROAR
                    player.taunttimer = 0 -- Reset the taunttimer to start the 2 seconds duration
                end
            end

            -- If in S_GODZILLA_ROAR state, stop the player from moving
            if player.mo.state == S_GODZILLA_ROAR then
                -- Stop the player's movement by zeroing movement velocities
                player.mo.momx = 0
                player.mo.momy = 0
                player.mo.momz = 0

                -- Check if 2 seconds have passed (2 seconds = 70 tics * 2)
                player.taunttimer = player.taunttimer + 1
                if player.taunttimer >= 140 then  -- 140 tics = 2 seconds
                    -- After 2 seconds, return to S_PLAY_STND state
                    player.mo.state = S_PLAY_STND
                end
            end
        end
    end
end)